#pragma once

#include "Object.h"
#include "Materials.h"

class BulletHole : public Object{
private:
	Vector3d _center, _normal; // vectors to hold the center and normal of the bullethole
	Materials _material; //color, fade etc
	float _size; // size of the bullet hole plane

	GLuint _texNum; //texture number

public:
	//constructor
	BulletHole():_size(0.05f){ _material.create(Color::black(), Color(1.0f,0.0f,0.0f,1.0f)); };
	BulletHole(const Vector3d & center, const Vector3d & normal);

	//init the bullet line with a center, normal
	void create(const Vector3d & center, const Vector3d & normal);

	//the draw function
	void draw() const;

	//fade the bullet line up or down
	void update() { _material.alphaDiffuse(-0.002f); };

	const bool isVisible() const { return _material.isVisible(); };

	//the read function - not used for gun, but needed to instanstiate
	void read(istream &){ return; };
};