#include "BulletLine.h"

/*------------------------------------------------------
* specific constructor
--------------------------------------------------------*/
BulletLine::BulletLine(const Vector3d & startPos, const Vector3d & endPos){
	_material.create(Color::black(), Color(1.0f,0.0f,0.0f,0.8f));
	create(startPos, endPos);
};

/*---------------------------------------------
* init the bullet line with a start, end
-----------------------------------------------*/
void BulletLine::create(const Vector3d & startPos, const Vector3d & endPos){
	_startPos.set(startPos);
	_endPos.set(endPos);
}

/*-----------------------------------------------------
* draw the line - fade it out over time
-------------------------------------------------------*/
void BulletLine::draw() const{
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); // enable blending

	_material.apply();
	glBegin(GL_LINES);
		glVertex3d(_startPos._x, _startPos._y-0.1,  _startPos._z); // start it slightly below eye level, so we can see the line
																	// if standing still
		glVertex3d(_endPos._x, _endPos._y,  _endPos._z);
	glEnd();

	glDisable(GL_BLEND);// disable blending
}