#pragma once

#include "Object.h"
#include "Materials.h"

class BulletLine : public Object{
private:
	Vector3d _startPos, _endPos; // vectors to hold the start and end position of the bullet line
	Materials _material; //color, fade etc

public:
	//constructor
	BulletLine(){ _material.create(Color::black(), Color(1.0f,0.0f,0.0f,1.0f)); };
	BulletLine(const Vector3d & startPos, const Vector3d & endPos);

	//init the bullet line with a start, end
	void create(const Vector3d & startPos, const Vector3d & endPos);

	//the draw function
	void draw() const;

	//fade the bullet line up or down
	void update() { _material.alphaDiffuse(-0.01f); };

	const bool isVisible() const { return _material.isVisible(); };

	//the read function - not used for gun, but needed to instanstiate
	void read(istream &){ return; };
};