#include "Color.h"

void Color::Assign(GLfloat r, GLfloat g, GLfloat b, GLfloat a) {
	_rgba[0] = r;
	_rgba[1] = g;
	_rgba[2] = b;
	_rgba[3] = a;
}
/*---------------------
* constructors
-----------------------*/
Color::Color() { 
	Assign(0.0, 0.0, 0.0, 0.0);
}
Color::Color(GLfloat r, GLfloat g, GLfloat b, GLfloat a) {
	Assign(r, g, b, a);
}
Color::Color(GLfloat rgba[]) {
	Assign(rgba[0], rgba[1], rgba[2], rgba[3]);
}

/*------------------------
* return the values held
--------------------------*/
const GLfloat* Color::rgba() const {
	return _rgba;
}

/*------------------------
* stock color setups
--------------------------*/
Color Color::black() {
	return Color(0.0, 0.0, 0.0, 1.0);
}
Color Color::white() {
	return Color(1.0, 1.0, 1.0, 1.0);
}
Color Color::red() {
	return Color(1.0, 0.0, 0.0, 1.0);
}
Color Color::green() {
	return Color(0.0, 1.0, 0.0, 1.0);
}
Color Color::blue() {
	return Color(0.0, 0.0, 1.0, 1.0);
}
Color Color::yellow() {
	return Color(1.0, 1.0, 0.0, 1.0);
}
Color Color::null() {
	return Color(0.0, 0.0, 0.0, 0.0);
}
/*------------------------
* write out function
--------------------------*/
ostream& Color::write(ostream &out){
	out << "(" << _rgba[0]
		<< ", " << _rgba[1]
		<< ", " << _rgba[2]
		<< ", " << _rgba[3] << ")";
	return out;
}

/*---------------------------------
* obtain specific atts
-----------------------------------*/
const float& Color::operator[](int i) const {
	return _rgba[i];
}

float& Color::operator[](int i) {
	return _rgba[i];
}
