#pragma once

#include "GXBase.h"
#include <iostream>
using namespace std;

class Color {
private:
	GLfloat _rgba[4];

	//common function used in construction
	void Assign(GLfloat r, GLfloat g, GLfloat b, GLfloat a);

public:
	//various constructors
	Color();
	Color(GLfloat r, GLfloat g, GLfloat b, GLfloat a);
	Color(GLfloat rgba[]);

	//return the values held
	const GLfloat* rgba() const;

	//some stock color setups
	static Color black();
	static Color white();
	static Color red();
	static Color green();
	static Color blue();
	static Color yellow();
	static Color null();

	//write out function
	ostream& write(ostream &out);

	//obtain specific atts
	const float& operator[](int i) const;
	float& operator[](int i);
};

//overloaded stream out operator
inline ostream &operator<<(ostream &out, Color &c) { c.write(out); return out; }