#pragma once

#include "GXBase.h"
//#include "Object.h"
#include "Plane.h"
#include <iostream>

using namespace std;

class Cuboid{//: public Object {
private:
	float _fWidth; //width of the cuboid
	float _fHeight; //height of the cuboid
	float _fDepth; //depth of the cuboid
	Plane _pFrontFace, _pBackFace, _pLeftFace, _pRightFace, _pTopFace, _pBottomFace; // plane objects for each of the four faces
	GLuint _iFrontTexture, _iBackTexture, _iLeftTexture, _iRightTexture, _iTopTexture, _iBottomTexture; //texture number for each face
	
	//build the cuboid - makes calls to the plane objects to draw
	void buildCuboid() const;

public:
	//constructor used in the streaming in
	Cuboid(){};

	~Cuboid(){}; //destructor

	//create the cuboid - initialize the planes
	void create(const float fWidth, const float fHeight, const float fDepth,
				const GLuint iFrontTexture, const GLuint iBackTexture, const GLuint iLeftTexture,
				const GLuint iRightTexture, const GLuint iTopTexture, const GLuint iBottomTexture,
				const bool repeatTexture=true);

	//draw it
	void draw() const;
};