#include "Cylinder.h"

/*------------------------------------------------------
* constructor - initialize some base variables
--------------------------------------------------------*/
Cylinder::Cylinder() {
	_fRadius = 1.0f;
	_fHeight = 1.0f;
	_iSlices = _iStacks = 20;
	_obj = NULL;
}

/*----------------------------------------------------
* destructor - delete the gluQuadric object
------------------------------------------------------*/
Cylinder::~Cylinder() {
	gluDeleteQuadric(_obj);
}

/*-------------------------------------------------------------
* create the cylinder - pass the radius, height
* creates a gluQuadric, with texture set to on
---------------------------------------------------------------*/
void Cylinder::create(const float radius, const float height, const GLuint texture) {
	_obj = gluNewQuadric(); //create a new quadric
	gluQuadricNormals(_obj, GLU_SMOOTH); //generate the normal
	_fRadius = radius; // assign the different variables
	_fHeight = height;
	_iTextureNum = texture;
	gluQuadricTexture(_obj, true); // set the texture flag
}

/*----------------------------------------------------------
* draw the sphere if the _obj object is present and its valid
------------------------------------------------------------*/
void Cylinder::draw() const {
	if (_obj){
		glBindTexture(GL_TEXTURE_2D, _iTextureNum); // bind our texture (received from the TextureManager)
		gluCylinder(_obj, _fRadius, _fRadius, _fHeight, _iSlices, _iStacks);
	}
}