#pragma once

#include "GXBase.h"
#include "Color.h"

class Materials {
private:
	Color _ambient;
	Color _diffuse;
	Color _emission;

	//setters for the various color types
	void setAmbient(const Color &ambient);
	void setDiffuse(const Color &diffuse);
	void setEmission(const Color &emission);

public:
	Materials();

	//common function used in construction
	void create(const Color &ambient=Color::black(), const Color &diffuse=Color::white(), const Color &emission=Color::null());

	//apply the material
	void apply() const;

	//fade down the diffuse color - used for blending
	void alphaDiffuse(const float inc);

	//set the alpha of the diffuse color to a specific value
	void setAlpha(const float value);

	const bool isVisible() const { return _diffuse[3] > 0.001f ? true : false; };
};

