#pragma once

#include "GXBase.h"
// include the math header, and define PI for later use
#include <math.h>
#define sPI  (float)3.1415926

class MySphere{
private:
	float (*_fVertexarray)[3];	// contains the vertices
	float (*_fNormalarray)[3];	// contains the normals to each vertex
	GLuint *_iIndexarray;		// index array that defines the polygons
	float (*_fTexarray)[2];		// texture coordinates for each vertex
	int _iStacks, _iSlices;
	GLfloat _fRadius;
	GLuint _iTextureNum, _dlSphere; //texture number, display list number

public:
	MySphere():_iStacks(20), _iSlices(20), _fRadius(1.0f){};
	~MySphere();

	//create the sphere
	void create(const GLfloat radius, const GLuint texture);

	//create the vertex, normal and index arrays for the sphere
	bool createArrays();

	void makeDisplayList(); // make the displaylist for the sphere

	//draw it
	void draw() const;
};

