#include "Object.h"

/*-------------------------------------------------------
* constructor
* set up the params and instaniate the TextureManager
* if there isn't one already
---------------------------------------------------------*/
Object::Object(){
	_sTextureName = "";
	_iTextureNumber = 0;
	_position.set(0.0, 0.0, 0.0);
};
/*------------------
* setters
--------------------*/
GLuint Object::textureNumber(const GLuint tnum){
	_iTextureNumber = tnum;
	return _iTextureNumber; // return the number after setting it
}

//set the object's positon using a Vector3d object
void Object::position(const Vector3d &R){
	_position._x = R._x;
	_position._y = R._y;
	_position._z = R._z;
}
//set the objects position using doubles
void Object::position(const double x, const double y, const double z){
	_position._x = x;
	_position._y = y;
	_position._z = z;
}

/*-----------------------------
texture manager for the objects
-------------------------------*/
//isAlphaMask is set to false by default
GLuint Object::getTexture(const string &name, bool isAlphaMask){
	return TextureManager::get()->getTexture(name, isAlphaMask); // call to the texture manager to get a texture
}