#include "PhysicsObject.h"

/*------------------------------------------
* draw the bounding box
--------------------------------------------*/
void PhysicsObject::drawBoundingBox() const{
	_boundingBox.draw();
}

/*------------------------------------------------
* set up the bounding box to it's default
--------------------------------------------------*/
void PhysicsObject::setBoundingBox() {
	_boundingBox.create(1.0, 1.0, 1.0, position());
}

/*-------------------------------------------------------------------
* set the bounding box up with params - position is set using Vector3d
-------------------------------------------------------------------*/
void PhysicsObject::setBoundingBox(const float w, const float h, const float d, const Vector3d &pos){
	_boundingBox.create(w, h, d, pos);
}

/*-------------------------------------------------------------------
* set the boundingbox up with params - position is set using floats
-------------------------------------------------------------------*/
void PhysicsObject::setBoundingBox(const float w, const float h, const float d, const double x, const double y, const double z){
	_boundingBox.create(w, h, d, x, y, z);
}

/*---------------------------------------------
* move the boundingBox
-----------------------------------------------*/
void PhysicsObject::moveBoundingBox(const double x, const double y, const double z){
	_boundingBox.move(x, y, z);
}

/*---------------------------------------
* move the boundingBox using a Vector3d
-----------------------------------------*/
void PhysicsObject::moveBoundingBox(const Vector3d &pos){
	_boundingBox.move(pos);
}