#include "Pipe.h"

/*-------------------------------------
* the draw function - calls on the
* object to draw
---------------------------------------*/
void Pipe::draw() const{
	glPushMatrix();
		glDisable(GL_CULL_FACE);
		glTranslated(xPos(), yPos(), zPos());
		if(_fRotateAngle != 0) glRotated(_fRotateAngle, _fRotateX, _fRotateY, _fRotateZ);
		_pipe.draw();
		glEnable(GL_CULL_FACE);
	glPopMatrix();
}

/*-------------------------------------------------
* onShot - add the steam particle engine
---------------------------------------------------*/
void Pipe::onShot(Vector3d & hitPos, Vector3d & hitNormal){
	ParticleManager::get()->addParticleEngine(hitPos, hitNormal);
}

/*-------------------------------------------------------------------------
* the read function - gets passed the istream from the ObjectMeshManager
---------------------------------------------------------------------------*/
void Pipe::read(istream &fin){
	char buffer[256], ch;
	string temp;

	fin.get(buffer, sizeof(buffer), '=');
	fin >> ch >> position(); // read in the position

	fin.get(buffer, sizeof(buffer), '=');
	fin >> ch >> _axis; // read in the axis

	fin.get(buffer, sizeof(buffer), '=');
	fin >> ch >> ch >> _fRotateAngle >> ch >> _fRotateX >> ch >> _fRotateY >> ch >> _fRotateZ >> ch; // read in the rotation

	fin.get(buffer, sizeof(buffer), '=');
	fin >> ch >> _fRadius; // read in the radius

	fin.get(buffer, sizeof(buffer), '=');
	fin >> ch >> _fHeight; // read in the height

	fin.get(buffer, sizeof(buffer), '=');
	fin >> ch >> ch >> temp >> ch; // read in the texture
	textureName(temp);
	_iTexNum = getTexture(temp); // assign the texture number

	fin.get(buffer, sizeof(buffer), '=');
	fin >> ch >> ch >> temp >> ch; // read in the id
	setID(temp); // set it

	_pipe.create(_fRadius, _fHeight, _iTexNum); // create the pipe
}

/*---------------------------------------------
* the write function - stream out the data
-----------------------------------------------*/
ostream& Pipe::write(ostream &out){
	out << "Pipe {"
		 << "\n\tposition= " << position()
		 << "\n\taxis= " << _axis
		 << "\n\trotation= (" << _fRotateAngle << ", " << _fRotateX << ", " << _fRotateY << ", " << _fRotateZ << " )"
		 << "\n\tradius= " << _fRadius
		 << "\n\theight= " << _fHeight
		 << "\n\ttexture= \"" << textureName() << " \""
		 << "\n\tid= \"" << getID() << " \""
		 << "\n}" << endl;
	return out;
}