#pragma once

#include "GXBase.h"
#include "PhysicsObject.h"
#include "ParticleManager.h"

class Pipe: public PhysicsObject {
private:
	Vector3d _axis; // pipe axis - which way is it heading
	Cylinder _pipe; // world representation of the pipe
	GLuint _iTexNum; //texture number
	float _fRadius, _fHeight; //radius of the pipe, height
	float _fRotateAngle, _fRotateX, _fRotateY, _fRotateZ; // rotate angle, x, y, z

public:
	//constructor - not used in the streaming in
	Pipe(){};

	~Pipe(){}; // destructor

	//onShot - add the steam particle engine
	void onShot(Vector3d & hitPos, Vector3d & hitNormal);

	// return the axis vector - used in the physicsIF class
	const Vector3d& axis() const { return _axis; };

	// return the cylinder radius - used in the physicsIF class
	const float& radius() const { return _fRadius; };

	//draw it
	void draw() const;

	//the read function - the istream gets passed from the ObjectMeshManager
	void read(istream &fin);

	//the write function
	ostream& write(ostream &out);
};