#pragma once

#include "GXBase.h"
#include <iostream>
using namespace std;

class Plane{//: public Object {
private:
	float _fWidth; //width of the plane
	float _fHeight; //height of the plane
	GLuint _iTextureNum; //texture number
	int _divisor; //divisor number for tesselating the plane
	float _textureDiv; // number of time to repeat the texture

	GLuint _dlPlane; // display list for the plane

	float (*_fVertexarray)[3];	// contains the vertices
	float (*_fNormalarray)[3];	// contains the normals to each vertex
	GLuint *_iIndexarray;		// index array that defines the polygons
	float (*_fTexarray)[2];		// texture coordinates for each vertex
	int _iRows, _iColumns;

public:
	Plane();

	~Plane(); // destructor

	//create function - used when plane is made from other classes, such as Cuboid
	void create(const float w, const float h, const GLuint iTextureNum, const bool repeatTexture=true);

	//create the vertex, normal and index arrays for the plane
	bool createArrays(const float width, const float height, const int rows, const int columns);

	void makeDisplayList(); // make the displaylist for the plane

	//draw it
	void draw() const;
};