#pragma once

#include "Object.h"

using namespace std;

class Skybox: public Object {
private:
	float _fWidth; //width of the Skybox
	float _fHeight; //height of the Skybox
	float _fDepth; //depth of the Skybox
	Plane _pFrontFace, _pBackFace, _pLeftFace, _pRightFace, _pTopFace, _pBottomFace; // plane objects for each of the four faces
	GLuint _iFrontTexture, _iBackTexture, _iLeftTexture, _iRightTexture, _iTopTexture, _iBottomTexture; //texture number for each face
	string _sFrontTexture, _sBackTexture, _sLeftTexture, _sRightTexture, _sTopTexture, _sBottomTexture; // texture names for each face

	//build the Skybox - makes calls to the plane objects to draw
	void buildSkybox() const;

public:
	//constructor used in the streaming in
	Skybox(){};

	~Skybox(){}; //destructor

	//create the cuboid - initialize the planes
	void create(const float fWidth, const float fHeight, const float fDepth,
				const GLuint iFrontTexture, const GLuint iBackTexture, const GLuint iLeftTexture,
				const GLuint iRightTexture, const GLuint iTopTexture, const GLuint iBottomTexture,
				const bool repeatTexture=true);

	//draw it
	void draw() const;

	//the read function - the istream gets passed from the ObjectMeshManager
	void read(istream &fin);

	//the write function
	ostream& write(ostream &out);
};