#pragma once

#include "GXBase.h"
#include "PhysicsObject.h"

class SolidBlockObject: public PhysicsObject {
private:
	float _fRotateAngle, _fRotateX, _fRotateY, _fRotateZ; // rotate angle, and which axis
	Cuboid _SolidBlockObject; // world representation of the cube
	string _sFrontTexture, _sBackTexture, _sLeftTexture, _sRightTexture, _sTopTexture, _sBottomTexture; //texture strings for each face
	GLuint _iFrontTexture, _iBackTexture, _iLeftTexture, _iRightTexture, _iTopTexture, _iBottomTexture; //texture number for each face
	string _type; // type of object - stair, platform, pillar etc

public:
	//constructor used in the streaming in
	SolidBlockObject(){};

	~SolidBlockObject(){}; // destructor

	//onShot - draw the bullethole
	void onShot(Vector3d & hitPos, Vector3d & hitNormal);

	//draw it
	void draw() const;

	//set the type
	void type(const string &type);

	//the read function - the istream gets passed from the ObjectMeshManager
	void read(istream &fin);

	//the write function
	ostream& write(ostream &out);

	//set the boundingBox - calls Object::setBoundingBox()
	void setupBoundingBox();
};