#include "Vector4f.h"

/*---------------------------------------
* common function used in construction
-----------------------------------------*/
void Vector4f::Assign(GLfloat x, GLfloat y, GLfloat z, GLfloat w) {
	_xyzw[0] = x;
	_xyzw[1] = y;
	_xyzw[2] = z;
	_xyzw[3] = w;
}

/*-----------------------------------------
* constructors
-------------------------------------------*/
Vector4f::Vector4f() { 
	Assign(0.0, 0.0, 0.0, 1.0);
}
Vector4f::Vector4f(GLfloat x, GLfloat y, GLfloat z, GLfloat w) {
	Assign(x, y, z, w);
}
Vector4f::Vector4f(GLfloat xyzw[]) {
	Assign(xyzw[0], xyzw[1], xyzw[2], xyzw[3]);
}

/*------------------------------------------
* return a const pointer to the _xyzw array
--------------------------------------------*/
const GLfloat* Vector4f::xyzw() const {
	return _xyzw;
}

/*--------------------------------------------------------
* gets and sets for specific parts of the _xyzw[] array
----------------------------------------------------------*/
const float& Vector4f::operator [](int i) const{
	return _xyzw[i];
}
float& Vector4f::operator [](int i){
	return _xyzw[i];
}

/*---------------------------------------------
* the write function - stream to file/console
-----------------------------------------------*/
ostream& Vector4f::write(ostream &out){
	out << "(" << _xyzw[0]
		<< ", " << _xyzw[1]
		<< ", " << _xyzw[2]
		<< ", " << _xyzw[3] << ")";
	return out;
}