#pragma once

#include "GXBase.h"
#include <iostream>
using namespace std;

class Vector4f {
private:
	GLfloat _xyzw[4];
	
	//common function used in construction
	void Assign(GLfloat x, GLfloat y, GLfloat z, GLfloat w);

public:

	//various overloaded constructors
	Vector4f();
	Vector4f(GLfloat x, GLfloat y, GLfloat z, GLfloat w);
	Vector4f(GLfloat xyzw[]);

	//return the _xyzw[] array
	const GLfloat* xyzw() const;

	//gets and sets for specific parts of the _xyzw[] array
	const float& operator[](int i) const;
	float& operator[](int i);

	//write out function
	ostream& write(ostream &out);
};

//overloaded stream out operator
inline ostream &operator<<(ostream &out, Vector4f &v) { v.write(out); return out; }
