#pragma once

#include "GXBase.h"
#include "PhysicsObject.h"

class Window: public PhysicsObject {
private:
	Cuboid _unBrokenWindow, _brokenWindow; // world representation of the window
	Materials _material; //color, fade etc
	string _sUnBrokenTexture, _sBrokenTexture; //texture strings for broken and unbroken
	GLuint _iUnBrokenTexture, _iBrokenTexture; //texture number for broken and unbroken
	bool _bIsBroken;

public:
	//constructor used in the streaming in
	Window();

	~Window(){}; // destructor

	//onShot - break the glass by changing which plane to draw
	void onShot(Vector3d &, Vector3d &) { _bIsBroken = true; };

	//see if the window is broken or not
	bool isBroken() const { return _bIsBroken; };

	//draw it
	void draw() const;

	//the read function - the istream gets passed from the ObjectMeshManager
	void read(istream &fin);

	//the write function
	ostream& write(ostream &out);

	//set the boundingBox - calls Object::setBoundingBox()
	void setupBoundingBox();
};